package hr.fer.diplomski.seminar.pso;

public class F1 implements Function {
	/** Vector space dimension */
	private static final int dim = 3;
	/** Function's minimum is achieved in this point */
	private static final double[] opt = { 0.0, 1.0, 2.0 };

	public F1() {
	}
	
	/** Function evaluates given parameters
	 *  @param parameters point of evaluation
	 *  @return function value in given point
	 */
	public double evaluate(double[] parameters) throws IllegalArgumentException {
		if (parameters.length != dim) {
			throw new IllegalArgumentException("In evaluate function "
					+ this.getClass().getCanonicalName()
					+ " given parameters don't match dimension");
		}
		double result = 0.0;
		for (int i = 0; i < dim; i++) {
			result += (parameters[i] - opt[i]) * (parameters[i] - opt[i]);
		}
		return result;
	}

	public int getDim() {
		return dim;
	}

	public double[] getOpt() {
		return opt;
	}

}
