package hr.fer.diplomski.seminar.pso;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Main class for swarm initialization.
 * Handles user input for parameters.
 * @author Marko Pletikosa 0036424228
 * @version alfa
 * 
 */
public class PSO {

	private static final String parameters = "Currnet program parameters:\n1.Function f1, 2.Swarm size 40 units\n"
			+ "3.#Iterations 100\n4.xMax 20\n5.xMin -20\n6.vMax 30\n7.Absolute error 1e-3\n8.c1 2.0\n9.c2 2.0";
	private static final String change = "If u wish to change parameters, enter"
			+ " the number of the parameter you wish to change or 0 if u want to stop";
	private static int swarmSize = 40, numIter = 100;
	private static double c1 = 2, c2 = 2;
	private static double xMax = 20, xMin = -20;
	private static double vMax = 30;
	private static double error = 1e-3;
	private static Function f = new F1();

	/**
	 * @param args
	 */
	public static void main(String[] args) {



		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		String line;

		System.out.println(parameters);
		System.out.println(change);
		char choice = '0';

		try {
			while (true) {
				line = reader.readLine();
				if (line.equals("0"))
					break;
				choice = line.charAt(0);
				switch (choice) {
				case '1':
					System.out
							.println("Enter 1 for function f1, or 6 for function f6");
					char function = reader.readLine().charAt(0);
					if (function == '1')
						f = new F1();
					else if (function == '6')
						f = new F6();
					break;
				case '2':
					System.out.println("Enter new swarm size");
					swarmSize = Integer.valueOf(reader.readLine());
					break;
				case '3':
					System.out.println("Enter number of iterations");
					numIter = Integer.valueOf(reader.readLine());
					break;
				case '4':
					System.out.println("Enter xMax");
					xMax = Double.valueOf(reader.readLine());
					break;
				case '5':
					System.out.println("Enter xMin");
					xMin = Double.valueOf(reader.readLine());
					break;
				case '6':
					System.out.println("Enter vMax");
					vMax = Double.valueOf(reader.readLine());
					break;
				case '7':
					System.out.println("Enter suitble abasolute error");
					error = Double.valueOf(reader.readLine());
					break;
				case '8':
					System.out.println("Enter new value for c1");
					c1 = Double.valueOf(reader.readLine());
					break;
				case '9':
					System.out.println("Enter new value for c2");
					c2 = Double.valueOf(reader.readLine());
					break;
				default:
					System.out.println("Entered wrong number");
				}
				System.out.println("Enter 0 to end or change more parameters");
			}
		} catch (IOException e) {
			System.err.println("System.in input error");
			e.printStackTrace();
		}

		Swarm swarm = new Swarm(swarmSize, f, xMax, xMin, vMax, c1, c2);
		swarm.iterate(numIter, error);
	}

}
